DROP TABLE FACTURACION.LINEAAMORTIZACION IF EXISTS;
DROP TABLE FACTURACION.Amortizacion IF EXISTS;

CREATE TABLE FACTURACION.Amortizacion (
       Numero INT NOT NULL
     , Fecha DATE
     , IdentificadorCliente INT
     , IRPF DOUBLE
     , Anyo INT NOT NULL
     , ImporteFactura DOUBLE
     , Identificador INT NOT NULL
     , PRIMARY KEY (Numero, Anyo)
     , CONSTRAINT FK_Amortizacion_1 FOREIGN KEY (IdentificadorCliente)
                  REFERENCES FACTURACION.Clientes (Identificador)
);

CREATE TABLE FACTURACION.LINEAAMORTIZACION (
       NumeroLinea INT NOT NULL
     , NumeroFactura INT NOT NULL
     , AnyoFactura INT NOT NULL
     , Cantidad DOUBLE
     , Descripcion CHAR(200)
     , Precio DOUBLE
     , IVA DOUBLE
     , Numero INT NOT NULL
     , Anyo INT NOT NULL
     , PRIMARY KEY (NumeroLinea, NumeroFactura, AnyoFactura)
     , CONSTRAINT FK_LINEAAMORTIZACION_1 FOREIGN KEY (NumeroFactura, Anyo)
                  REFERENCES FACTURACION.Amortizacion (Numero, Anyo)
);

