package es.dalocar.software.daos;

// Generated 29-oct-2009 22:34:39 by Hibernate Tools 3.2.4.GA

import java.util.List;

import org.apache.log4j.Logger;
import org.hibernate.LockMode;
import org.hibernate.SessionFactory;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

import es.dalocar.software.beans.Factura;
import es.dalocar.software.beans.LineaFactura;

/**
 * Home object for domain model class LineaFactura.
 * 
 * @see es.dalocar.software.beans.LineaFactura
 * @author Hibernate Tools
 */
public class LineaFacturaDAO extends HibernateDaoSupport {

	private static final Logger log = Logger.getLogger(LineaFacturaDAO.class);
	private static final boolean DEBUG = log.isDebugEnabled();

	private final SessionFactory sessionFactory = getSessionFactory();

	public void persist(LineaFactura transientInstance) {
		if (DEBUG)
			log.debug("persisting LineaFactura instance");
		try {
			getHibernateTemplate().persist(transientInstance);
			if (DEBUG)
				log.debug("persist successful");
		} catch (RuntimeException re) {
			log.error("persist failed", re);
			throw re;
		}
	}
	
	/**
	 * Distingue si debe guardar o salvar el objeto en cuestin
	 * @param instance
	 */
	public void saveOrUpdate(LineaFactura instance) {
		if (DEBUG)
			log.debug("saving or updating LineaFactura instance");
		try {
			getHibernateTemplate().saveOrUpdate(instance);
			if (DEBUG)
				log.debug("saveOrUpdate successful");
		} catch (RuntimeException re) {
			log.error("persist failed", re);
			throw re;
		}
	}

	public void attachDirty(LineaFactura instance) {
		if (DEBUG)
			log.debug("attaching dirty LineaFactura instance");
		try {
			getHibernateTemplate().saveOrUpdate(instance);
			if (DEBUG)
				log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}

	public void attachClean(LineaFactura instance) {
		if (DEBUG)
			log.debug("attaching clean LineaFactura instance");
		try {
			getHibernateTemplate().lock(instance, LockMode.NONE);
			if (DEBUG)
				log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}

	public void delete(LineaFactura persistentInstance) {
		if (DEBUG)
			log.debug("deleting LineaFactura instance");
		try {
			getHibernateTemplate().delete(persistentInstance);
			if (DEBUG)
				log.debug("delete successful");
		} catch (RuntimeException re) {
			log.error("delete failed", re);
			throw re;
		}
	}
	
	/**
	 * Elimina las lineas de una factura para guardarlas posteriormente
	 * @param factura
	 */
	public void deleteFromFactura(Factura factura) {
		if (DEBUG)
			log.debug("deleting LineaFactura instance from Factura");
		try {
			getHibernateTemplate().deleteAll(findByFactura(factura));
			if (DEBUG)
				log.debug("delete successful");
		} catch (RuntimeException re) {
			log.error("delete failed", re);
			throw re;
		}
	}

	/**
	 * Persiste las lineas de una factura
	 * @param factura
	 */
	public void saveLineasFactura(Factura factura) {
		if (DEBUG)
			log.debug("saving all LineaFactura instances from Factura");
		try {
			deleteFromFactura(factura);
			getHibernateTemplate().saveOrUpdateAll(factura.getLineaFacturas());
			if (DEBUG)
				log.debug("saved All  successful");
		} catch (RuntimeException re) {
			log.error("saveLineasFacturas failed", re);
			throw re;
		}
	}
	
	
	public LineaFactura merge(LineaFactura detachedInstance) {
		if (DEBUG)
			log.debug("merging LineaFactura instance");
		try {
			LineaFactura result = (LineaFactura) sessionFactory
					.getCurrentSession().merge(detachedInstance);
			if (DEBUG)
				log.debug("merge successful");
			return result;
		} catch (RuntimeException re) {
			log.error("merge failed", re);
			throw re;
		}
	}

	public LineaFactura findById(es.dalocar.software.beans.LineaFacturaId id) {
		if (DEBUG)
			log.debug("getting LineaFactura instance with id: " + id);
		try {
			LineaFactura instance = (LineaFactura) sessionFactory
					.getCurrentSession().get(
							"es.dalocar.software.beans.LineaFactura", id);
			if (instance == null) {
				if (DEBUG)
					log.debug("get successful, no instance found");
			} else {
				if (DEBUG)
					log.debug("get successful, instance found");
			}
			return instance;
		} catch (RuntimeException re) {
			log.error("get failed", re);
			throw re;
		}
	}

	public List findByExample(LineaFactura instance) {
		if (DEBUG)
			log.debug("finding LineaFactura instance by example");
		try {
			List results = getHibernateTemplate().findByExample(instance);
			if (DEBUG)
				log.debug("find by example successful, result size: "
						+ results.size());
			return results;
		} catch (RuntimeException re) {
			log.error("find by example failed", re);
			throw re;
		}
	}

	/**
	 * @param factura
	 * @return
	 */
	public List findByFactura(es.dalocar.software.beans.Factura factura) {

		if (DEBUG)
			log.debug("finding LineaFactura instance by example");
		try {
		
			List results = getHibernateTemplate().find("from LineaFactura where " +
					"id.numerofactura=" + factura.getId().getNumero()+ " " +
					"and id.anyofactura=" + factura.getId().getAnyo() + " order by id.numerolinea" );			
			if (DEBUG)
				log.debug("find by query successful, result size: "
						+ results.size());
			return results;
		} catch (RuntimeException re) {
			log.error("find by example failed", re);
			throw re;
		}
	}
}
