/**
 * 
 */
package es.dalocar.facturamas.reports;


import net.sf.jasperreports.engine.JRException;
import net.sf.jasperreports.engine.JasperExportManager;
import net.sf.jasperreports.view.JasperViewer;

/**
 * Clase utilizada para la generacin de informes
 * @author dlopez
 *
 */
public class Reporter {
	
	/**
	 * Mostrar visor de informes
	 * @param report
	 */
	public static void view(Report report) {
		JasperViewer.viewReport(report.getJasperPrint(), false);		
	}
	
	/**
	 * Exportar un informe a un flujo de bytes PDF.
	 * @param report Informe a exportar.
	 * @return pdfBytes Vector de bytes con el informe en formato pdf.
	 */
	public static byte[] export(Report report){
		byte[] pdfBytes = null;
		try {
			pdfBytes = JasperExportManager.exportReportToPdf(report.getJasperPrint());			
		} catch (JRException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return pdfBytes;
	}

	
	
	
}
